module Soar
  module Registry
    module Staff
      module Test
        module Directory
          class Orchestrator

            attr_reader :directory

            def initialize(provider)
              @provider = provider
              @directory = provider.directory
            end

            def reset_data
              clear_data
              load_sample_data
            end

            def clear_data
              @directory.bootstrap(valid_configuration['provider']['config'])
              @directory.authenticate(valid_credentials)
              @directory.connect
              delete_data_structure
              create_data_structure
            end

            def connection_error
              @provider.connection_error
            end

            def networking_error
              @provider.networking_error
            end

            def delete_data_structure
              @provider.delete_data_structure
            end

            def create_data_structure
              @provider.create_data_structure
            end

            def load_sample_data
              @provider.load_sample_data
            end

            def valid_configuration
              @provider.valid_configuration
            end

            def valid_configuration?(config)
              @provider.valid_configuration?(config)
            end

            def invalid_configuration(config)
              @provider.invalid_configuration(config)
            end

            def valid_credentials?(credentials)
              @provider.valid_credentials?(credentials)
            end

            def valid_credentials
              @provider.valid_credentials
            end

            def invalid_credentials(credentials)
              @provider.invalid_credentials(credentials)
            end

          end
        end
      end
    end
  end
end
