require 'hashie'
require 'yaml'

module Soar
  module Registry
    module Staff
      module Test
        module Directory
          module Provider
            class Base

              attr_reader :directory
              attr_reader :identities

              def valid_credentials
                valid_config = valid_configuration
                valid_config['provider']['credentials']
              end

              def valid_configuration
                @config
              end

              def invalid_credentials(valid_credentials)
                invalid_credentials = []
                ['username', 'password'].each { |index| 
                  credentials = deep_copy(valid_credentials)
                  credentials.delete(index)
                  invalid_credentials << credentials
                }
                return invalid_credentials
              end

              private 

              def deep_copy(obj)
                return Marshal.load(Marshal.dump(obj))
              end

            end
          end
        end
      end
    end
  end
end
